# Copyright (c) 1991-2001 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.

# ======== General Defaults ==============================================

CONFIG = $(TARGET).$(LIBRARY_SET)

# Defaults for macros which may be modified by
#    libset/$(LIBRARY_SET)/libset.mk
#    target/$(TARGET)/target.mk
# or config/$(CONFIG)/config.mk

PERL          = rtperl
FEEDBACK      = $(PERL) "$(RTS_HOME)/tools/feedback.pl"
MERGE         = $(PERL) "$(RTS_HOME)/tools/merge.pl"
NOP           = $(PERL) "$(RTS_HOME)/tools/nop.pl"
RM            = $(PERL) "$(RTS_HOME)/tools/rm.pl"
RMF           = $(RM) -f
TOUCH         = $(PERL) "$(RTS_HOME)/tools/touch.pl"

# codegen makefiles stuff

RTGEN         = rtcppgen
RTCOMP        = $(PERL) "$(RTS_HOME)/codegen/rtcomp.pl"
RTLINK        = $(PERL) "$(RTS_HOME)/codegen/rtlink.pl"
VENDOR        = generic

# Macros used when make must recurse

MAKEFILE      = Makefile

# Macros used when creating an object file from a C++ source file

CC            = $(FEEDBACK) -fail \
		    CC should be defined by libset.mk or generated makefile
DEBUG_TAG     = -g
DEPEND_TAG    = -I
DEFINE_TAG    = -D
INCLUDE_TAG   = -I
LIBSETCCEXTRA =
LIBSETCCFLAGS =
OBJECT_OPT    = -c
OBJOUT_OPT    = -o
OBJOUT_TAG    =
SHLIBCCFLAGS  = -PIC
TARGETCCFLAGS =

# Macros used when creating an object library from a set of object files

AR_CMD        = $(PERL) "$(RTS_HOME)/tools/ar.pl"
AR            = $(AR_CMD)
LIBOUT_OPT    =
LIBOUT_TAG    =

# Macros used when creating an shared library from a set of object files

SHLIB_CMD     = $(FEEDBACK) -fail Shared libraries not supported.
SHLIBOUT_OPT  = -o
SHLIBOUT_TAG  =

# Macros used when creating an executable from a set of object files, libraries

LD            = $(CC)
DIR_TAG       = -L
LIBSETLDFLAGS =
LIB_TAG       = -l
OT_LIB_TAG    = -l
TARGETLDFLAGS =
TARGETLIBS    =
EXEOUT_OPT    = -o
EXEOUT_TAG    =

# Macros used to construct names of various kinds of files

EXEC_EXT      =
LIB_PFX       = lib
LIB_EXT       = .a
CPP_EXT       = .cc
OBJ_EXT       = .o
SHLIB_PFX     = lib
SHLIB_EXT     = .so

# ========= Shared Macros ================================================

RTSYSTEM_INCPATHS = \
	$(INCLUDE_TAG)"$(RTS_HOME)/libset/$(LIBRARY_SET)" \
	$(INCLUDE_TAG)"$(RTS_HOME)/target/$(TARGET)" \
	$(INCLUDE_TAG)"$(RTS_HOME)/include"

RTS_LIBRARY   = $(RTS_HOME)/lib/$(CONFIG)

SYSTEM_LIBS   = $(DIR_TAG)"$(RTS_LIBRARY)" \
		$(OT_LIB_TAG)ObjecTime \
		$(OT_LIB_TAG)ObjecTimeTypes

# ========= Linking ======================================================

LD_OUT = $@

LD_HEAD = \
	$(EXEOUT_OPT) $(EXEOUT_TAG)$(LD_OUT) \
	$(LIBSETLDFLAGS) \
	"$(RTS_LIBRARY)/main$(OBJ_EXT)"

ALL_OBJS_LIST = $(ALL_OBJS)

LD_TAIL = \
	$(SYSTEM_LIBS) \
	$(TARGETLDFLAGS) \
	$(TARGETLIBS)

# ======== Compiling =====================================================

CC_HEAD = \
	$(OBJECT_OPT) $(OBJOUT_OPT) $(OBJOUT_TAG)$@ \
	$(LIBSETCCFLAGS) \
	$(TARGETCCFLAGS) \
	$(RTSYSTEM_INCPATHS)

CC_TAIL =

# ========================================================================
