/*
 * Copyright (c) 1991-2001 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#ifndef __RTDcsTarget_h__
#define __RTDcsTarget_h__ included

// Connexis configuration
// Modification of the following settings is not recommended.

// Refer to the Connexis User Guide for additional information on thread
// functionality.

// Minimum value user can assign as a thread priority
#define CNX_PRIORITY_MIN                        1
// Maximum value user can assign as a thread priority
#define CNX_PRIORITY_MAX                        99
// Value to raise the priority of the Helper thread over the Transport Thread
#define CNX_PRIORITY_RAISE                      5

// Notes:
//  1) the default priorities can be overridden via the system configuration
//     parameters
//  2) the Callback thread runs at the same priority as the Transport thread
//  3) the Helper thread defaults to a higher priority than the Transport thread

// Default priority for Connexis Transport thread
#define DEFAULT_CNXTTP_PRIORITY         65
// Default priority for Connexis Helper threads
#define DEFAULT_CNXTHTP_PRIORITY        60
// Recommended default priority for Connexis DCS and Locator Capsules.
#define DEFAULT_CNXDTP_PRIORITY         75
// Default priority for Connexis debug Agent thread
#define DEFAULT_CNXATP_PRIORITY         85
// Default priority for Connexis ORB threads
#define DEFAULT_CNXODP_PRIORITY         75

// Stack size of Connexis Transport thread
#define CNXTTP_STACK                    8000
// Stack size of Connexis Helper thread
#define CNXTHTP_STACK                   16000
// Recommended minimum stack size for Connexis DCS and Locator Capsules
#define CNXDTP_STACK                    8000
// Stack size of Connexis debug Agent thread
#define CNXATP_STACK                    8000
// Stack size of Connexis ORB threads
#define CNXODP_STACK                    10000

#endif // __RTDcsTarget_h__
