// {{{RME classifier 'Logical View::Basic::BetweenLights'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "BetweenLights.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <BetweenLights.h>

const RTProtocolDescriptor BetweenLights::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &BetweenLights::Conjugate::rt_class
  , "BetweenLights"
  , 0
  , 4
  , BetweenLights::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor BetweenLights::Base::rt_signals[] =
{
	{
		"id"
	  , &RTType_int
	  , BetweenLights::Base::rti_id
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , BetweenLights::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , BetweenLights::Base::rti_rtUnbound
	}
  , {
		"turningRed"
	  , &RTType_void
	  , BetweenLights::Base::rti_turningRed
	}
};

const RTProtocolDescriptor BetweenLights::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &BetweenLights::Base::rt_class
  , "BetweenLights"
  , 0
  , 4
  , BetweenLights::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor BetweenLights::Conjugate::rt_signals[] =
{
	{
		"id"
	  , &RTType_int
	  , BetweenLights::Conjugate::rti_id
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , BetweenLights::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , BetweenLights::Conjugate::rti_rtUnbound
	}
  , {
		"turningRed"
	  , &RTType_void
	  , BetweenLights::Conjugate::rti_turningRed
	}
};

// }}}RME
