// {{{RME classifier 'Logical View::Basic::BetweenLights'

#ifndef BetweenLights_H
#define BetweenLights_H

#ifdef PRAGMA
#pragma interface "BetweenLights.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>

struct BetweenLights
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_turningRed = rtiLast_RTRootProtocol + 1
		  , rti_id
		};

	protected:
		enum { rtiLast_BetweenLights = rti_id };

	public:
		inline RTSymmetricSignal turningRed( void );
		inline RTInSignal id( void );
		inline RTOutSignal id( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_turningRed = rtiLast_RTRootProtocol + 1
		  , rti_id
		};

	protected:
		enum { rtiLast_BetweenLights = rti_id };

	public:
		inline RTSymmetricSignal turningRed( void );
		inline RTInSignal id( void );
		inline RTOutSignal id( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline BetweenLights::Base::Base( void )
	: RTRootProtocol()
{
}

inline BetweenLights::Base::~Base( void )
{
}

inline RTSymmetricSignal BetweenLights::Base::turningRed( void )
{
	return RTSymmetricSignal( this, rti_turningRed, Conjugate::rti_turningRed );
}

inline RTInSignal BetweenLights::Base::id( void )
{
	return RTInSignal( this, rti_id );
}

inline RTOutSignal BetweenLights::Base::id( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_id, &data, &RTType_int );
}

inline BetweenLights::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline BetweenLights::Conjugate::~Conjugate( void )
{
}

inline RTSymmetricSignal BetweenLights::Conjugate::turningRed( void )
{
	return RTSymmetricSignal( this, rti_turningRed, Base::rti_turningRed );
}

inline RTInSignal BetweenLights::Conjugate::id( void )
{
	return RTInSignal( this, rti_id );
}

inline RTOutSignal BetweenLights::Conjugate::id( const int & data )
{
	return RTOutSignal( this, Base::rti_id, &data, &RTType_int );
}

#endif /* BetweenLights_H */

// }}}RME
