// {{{RME classifier 'Logical View::Basic::Intersection'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Intersection.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <Intersection.h>
#include <BetweenLights.h>
extern const RTActorClass TrafficLight;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR
// }}}USR
// }}}RME

static RTActor * new_Intersection_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Intersection_Actor( _rts, _ref );
}

const RTActorClass Intersection =
{
	(const RTActorClass *)0
  , "Intersection"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_Intersection_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_trafficLightB[] =
{
	{
		"betweenLights"
	  , 1
	}
  , {
		"WalkSign"
	  , 0
	}
};

static const RTBindingDescriptor rtg_bindings_trafficLightB[] =
{
	{
		0
	  , &BetweenLights::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_trafficLightA[] =
{
	{
		"betweenLights"
	  , 1
	}
  , {
		"WalkSign"
	  , 0
	}
};

static const RTBindingDescriptor rtg_bindings_trafficLightA[] =
{
	{
		0
	  , &BetweenLights::Base::rt_class
	}
};

#define SUPER RTActor

Intersection_Actor::Intersection_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Intersection_Actor::~Intersection_Actor( void )
{
}

int Intersection_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// trafficLightB
		switch( rtg_portId )
		{
		case 0:
			// betweenLights
			if( rtg_repIndex < 1 )
			{
				// trafficLightA/betweenLights
				return trafficLightA._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// trafficLightA
		switch( rtg_portId )
		{
		case 0:
			// betweenLights
			if( rtg_repIndex < 1 )
			{
				// trafficLightB/betweenLights
				return trafficLightB._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void Intersection_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Intersection_Actor::getActorData( void ) const
{
	return &Intersection_Actor::rtg_class;
}

const RTActor_class Intersection_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , Intersection_Actor::rtg_parent_state
  , &Intersection
  , 2
  , Intersection_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Intersection_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor Intersection_Actor::rtg_capsule_roles[] =
{
	{
		"trafficLightB"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, trafficLightB )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_trafficLightB
	  , 1
	  , rtg_bindings_trafficLightB
	}
  , {
		"trafficLightA"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, trafficLightA )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_trafficLightA
	  , 1
	  , rtg_bindings_trafficLightA
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR
// }}}USR
// }}}RME

// }}}RME
