// {{{RME classifier 'Logical View::VariantAustrian::IntersectionAustrian'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "IntersectionAustrian.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <IntersectionAustrian.h>
#include <BetweenLights.h>
#include <OnOffProtocol.h>
extern const RTActorClass TrafficLightAustrian;
extern const RTActorClass WalkLight;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR
// }}}USR
// }}}RME

static RTActor * new_IntersectionAustrian_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new IntersectionAustrian_Actor( _rts, _ref );
}

const RTActorClass IntersectionAustrian =
{
	&Intersection
  , "IntersectionAustrian"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_IntersectionAustrian_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_trafficLightB[] =
{
	{
		"betweenLights"
	  , 1
	}
  , {
		"WalkSign"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_trafficLightB[] =
{
	{
		0
	  , &BetweenLights::Base::rt_class
	}
  , {
		1
	  , &OnOffProtocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_trafficLightA[] =
{
	{
		"betweenLights"
	  , 1
	}
  , {
		"WalkSign"
	  , 0
	}
};

static const RTBindingDescriptor rtg_bindings_trafficLightA[] =
{
	{
		0
	  , &BetweenLights::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_walkLightR1[] =
{
	{
		"switchPort"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_walkLightR1[] =
{
	{
		0
	  , &OnOffProtocol::Conjugate::rt_class
	}
};

#define SUPER Intersection_Actor

IntersectionAustrian_Actor::IntersectionAustrian_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: Intersection_Actor( rtg_rts, rtg_ref )
{
}

IntersectionAustrian_Actor::~IntersectionAustrian_Actor( void )
{
}

int IntersectionAustrian_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// trafficLightB
		switch( rtg_portId )
		{
		case 0:
			// betweenLights
			if( rtg_repIndex < 1 )
			{
				// trafficLightA/betweenLights
				return trafficLightA._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// WalkSign
			if( rtg_repIndex < 1 )
			{
				// walkLightR1/switchPort
				return walkLightR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// trafficLightA
		switch( rtg_portId )
		{
		case 0:
			// betweenLights
			if( rtg_repIndex < 1 )
			{
				// trafficLightB/betweenLights
				return trafficLightB._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// walkLightR1
		switch( rtg_portId )
		{
		case 0:
			// switchPort
			if( rtg_repIndex < 1 )
			{
				// trafficLightB/WalkSign
				return trafficLightB._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return Intersection_Actor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void IntersectionAustrian_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME classifier 'Logical View::Basic::Intersection' state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * IntersectionAustrian_Actor::getActorData( void ) const
{
	return &IntersectionAustrian_Actor::rtg_class;
}

const RTActor_class IntersectionAustrian_Actor::rtg_class =
{
	&Intersection_Actor::rtg_class
  , rtg_state_names
  , 1
  , IntersectionAustrian_Actor::rtg_parent_state
  , &IntersectionAustrian
  , 3
  , IntersectionAustrian_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId IntersectionAustrian_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor IntersectionAustrian_Actor::rtg_capsule_roles[] =
{
	{
		"trafficLightB"
	  , &TrafficLightAustrian
	  , RTOffsetOf( IntersectionAustrian_Actor, trafficLightB )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_trafficLightB
	  , 2
	  , rtg_bindings_trafficLightB
	}
  , {
		"trafficLightA"
	  , &TrafficLightAustrian
	  , RTOffsetOf( IntersectionAustrian_Actor, trafficLightA )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_trafficLightA
	  , 1
	  , rtg_bindings_trafficLightA
	}
  , {
		"walkLightR1"
	  , &WalkLight
	  , RTOffsetOf( IntersectionAustrian_Actor, walkLightR1 )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_walkLightR1
	  , 1
	  , rtg_bindings_walkLightR1
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR
// }}}USR
// }}}RME

// }}}RME
