// {{{RME classifier 'Logical View::Hardware::OnOffProtocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "OnOffProtocol.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <OnOffProtocol.h>

const RTProtocolDescriptor OnOffProtocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &OnOffProtocol::Conjugate::rt_class
  , "OnOffProtocol"
  , 0
  , 5
  , OnOffProtocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor OnOffProtocol::Base::rt_signals[] =
{
	{
		"off"
	  , &RTType_void
	  , OnOffProtocol::Base::rti_off
	}
  , {
		"on"
	  , &RTType_void
	  , OnOffProtocol::Base::rti_on
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , OnOffProtocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , OnOffProtocol::Base::rti_rtUnbound
	}
  , {
		"testSound"
	  , &RTType_void
	  , OnOffProtocol::Base::rti_testSound
	}
};

const RTProtocolDescriptor OnOffProtocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &OnOffProtocol::Base::rt_class
  , "OnOffProtocol"
  , 0
  , 2
  , OnOffProtocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor OnOffProtocol::Conjugate::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , OnOffProtocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , OnOffProtocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
