// {{{RME classifier 'Logical View::Hardware::OnOffProtocol'

#ifndef OnOffProtocol_H
#define OnOffProtocol_H

#ifdef PRAGMA
#pragma interface "OnOffProtocol.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>

struct OnOffProtocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_on = rtiLast_RTRootProtocol + 1
		  , rti_off
		  , rti_testSound
		};

	protected:
		enum { rtiLast_OnOffProtocol = rti_testSound };

	public:
		inline RTInSignal on( void );
		inline RTInSignal off( void );
		inline RTInSignal testSound( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_OnOffProtocol = rtiLast_RTRootProtocol };

	public:
		inline RTOutSignal on( void );
		inline RTOutSignal off( void );
		inline RTOutSignal testSound( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline OnOffProtocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline OnOffProtocol::Base::~Base( void )
{
}

inline RTInSignal OnOffProtocol::Base::on( void )
{
	return RTInSignal( this, rti_on );
}

inline RTInSignal OnOffProtocol::Base::off( void )
{
	return RTInSignal( this, rti_off );
}

inline RTInSignal OnOffProtocol::Base::testSound( void )
{
	return RTInSignal( this, rti_testSound );
}

inline OnOffProtocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline OnOffProtocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal OnOffProtocol::Conjugate::on( void )
{
	return RTOutSignal( this, Base::rti_on, (const void *)0, &RTType_void );
}

inline RTOutSignal OnOffProtocol::Conjugate::off( void )
{
	return RTOutSignal( this, Base::rti_off, (const void *)0, &RTType_void );
}

inline RTOutSignal OnOffProtocol::Conjugate::testSound( void )
{
	return RTOutSignal( this, Base::rti_testSound, (const void *)0, &RTType_void );
}

#endif /* OnOffProtocol_H */

// }}}RME
