// {{{RME classifier 'Logical View::Basic::TrafficLight'

#ifndef TrafficLight_H
#define TrafficLight_H

#ifdef PRAGMA
#pragma interface "TrafficLight.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <BetweenLights.h>
#include <IdProvider.h>
#include <OnOffProtocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
// }}}USR
// }}}RME

extern const RTActorClass TrafficLight;

#define SUPER RTActor
class TrafficLight_Actor : public RTActor
{
public:
	// {{{RME classAttribute 'timerId'
	RTTimerId timerId;
	// }}}RME
	// {{{RME classAttribute 'myId'
	int myId;
	// }}}RME
	// {{{RME classAttribute 'idProvider'
	IdProvider idProvider;
	// }}}RME

protected:
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	// {{{RME port 'betweenLights'
	BetweenLights::Base betweenLights;
	// }}}RME
	// {{{RME port 'WalkSign'
	OnOffProtocol::Conjugate WalkSign;
	// }}}RME
	TrafficLight_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~TrafficLight_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction1:timeout'
	INLINE_METHODS void transition4_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction3:idToEarly'
	INLINE_METHODS void transition5_idToEarly( const int * rtdata, BetweenLights::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:initializing:flashingAmber:Junction2:msgFromOtherLight'
	INLINE_METHODS void transition6_msgFromOtherLight( const int * rtdata, BetweenLights::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:initializing:flashingAmber:Junction1:Initial'
	INLINE_METHODS void transition10_Initial( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:initializing:flashingAmber:on:Junction3:msgFromOtherLight'
	INLINE_METHODS void transition14_msgFromOtherLight( const int * rtdata, BetweenLights::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:Junction2:timeout'
	INLINE_METHODS void transition18_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:green:Junction2:True'
	INLINE_METHODS void transition21_True( const int * rtdata, BetweenLights::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain4_timeout( void );
	INLINE_CHAINS void chain5_idToEarly( void );
	INLINE_CHAINS void chain12_timeout( void );
	INLINE_CHAINS void chain14_msgFromOtherLight( void );

protected:
	// {{{RME choicePoint ':TOP:initializing:IHavePriority'
	INLINE_METHODS int choicePoint1_IHavePriority( const int * rtdata, BetweenLights::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain8_True( void );
	INLINE_CHAINS void chain9_False( void );
	INLINE_CHAINS void chain11_timeout( void );
	INLINE_CHAINS void chain13_msgFromOtherLight( void );
	INLINE_CHAINS void chain16_greenTimeout( void );
	INLINE_CHAINS void chain18_timeout( void );
	INLINE_CHAINS void chain17_otherRed( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_TrafficLight_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR
// }}}USR
// }}}RME

#endif /* TrafficLight_H */

// }}}RME
