// {{{RME classifier 'Logical View::VariantAustrian::TrafficLightAustrian'

#ifndef TrafficLightAustrian_H
#define TrafficLightAustrian_H

#ifdef PRAGMA
#pragma interface "TrafficLightAustrian.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <TrafficLight.h>
class Constants;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include<process.h>
// }}}USR
// }}}RME

extern const RTActorClass TrafficLightAustrian;

#define SUPER TrafficLight_Actor
class TrafficLightAustrian_Actor : public TrafficLight_Actor
{
public:
	// {{{RME classAttribute 'numberFlashes'
	int numberFlashes;
	// }}}RME
	TrafficLightAustrian_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~TrafficLightAustrian_Actor( void );

protected:
	// {{{RME operation 'playSound20()'
	void playSound20( void );
	// }}}RME
	// {{{RME operation 'playSound19()'
	void playSound19( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:working:green'
	INLINE_METHODS void enter7_green( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME enter ':TOP:working:red'
	INLINE_METHODS void enter9_red( void );
	// }}}RME
	// {{{RME exit ':TOP:working:red'
	INLINE_METHODS void exit9_red( void );
	// }}}RME
	virtual void exitStateV( void );
	// {{{RME transition ':TOP:working:green:Junction2:True'
	INLINE_METHODS void transition21_True( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:flashingGreen:Junction2:timeout'
	INLINE_METHODS void transition23_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:Junction1:timeout3'
	INLINE_METHODS void transition24_timeout3( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:Junction3:otherRed'
	INLINE_METHODS void transition25_otherRed( const void * rtdata, BetweenLights::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:flashingGreen:Junction1:timeout3'
	INLINE_METHODS void transition27_timeout3( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:flashingGreen:lightOff:Junction2:timeout'
	INLINE_METHODS void transition28_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:working:transitioning:flashingGreen:flashedEnough:True'
	INLINE_METHODS void transition29_True( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain4_timeout( void );
	INLINE_CHAINS void chain5_idToEarly( void );
	INLINE_CHAINS void chain12_timeout( void );
	INLINE_CHAINS void chain14_msgFromOtherLight( void );
	INLINE_CHAINS void chain8_True( void );
	INLINE_CHAINS void chain9_False( void );
	INLINE_CHAINS void chain11_timeout( void );
	INLINE_CHAINS void chain13_msgFromOtherLight( void );
	INLINE_CHAINS void chain16_greenTimeout( void );
	INLINE_CHAINS void chain17_otherRed( void );
	INLINE_CHAINS void chain22_timeout( void );
	INLINE_CHAINS void chain31_timeout( void );
	INLINE_CHAINS void chain28_timeout( void );

protected:
	// {{{RME choicePoint ':TOP:working:transitioning:flashingGreen:flashedEnough'
	INLINE_METHODS int choicePoint2_flashedEnough( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain29_True( void );
	INLINE_CHAINS void chain30_False( void );
	INLINE_CHAINS void chain26_timeout( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR
// }}}USR
// }}}RME

#endif /* TrafficLightAustrian_H */

// }}}RME
