// {{{RME classifier 'Logical View::Hardware::WalkLight'

#ifndef WalkLight_H
#define WalkLight_H

#ifdef PRAGMA
#pragma interface "WalkLight.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <OnOffProtocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include<process.h>
// }}}USR
// }}}RME

extern const RTActorClass WalkLight;

#define SUPER RTActor
class WalkLight_Actor : public RTActor
{
public:
	// {{{RME port 'switchPort'
	OnOffProtocol::Base switchPort;
	// }}}RME

protected:
	// {{{RME port 'log'
	Log::Base log;
	// }}}RME

public:
	WalkLight_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~WalkLight_Actor( void );

protected:
	// {{{RME operation 'setAllPixels()'
	void setAllPixels( void );
	// }}}RME
	// {{{RME operation 'unsetAllPixels()'
	void unsetAllPixels( void );
	// }}}RME
	// {{{RME operation 'playCrossSound()'
	void playCrossSound( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Off:Junction2:on'
	INLINE_METHODS void transition2_on( const void * rtdata, OnOffProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:On:Junction2:off'
	INLINE_METHODS void transition3_off( const void * rtdata, OnOffProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction1:test'
	INLINE_METHODS void transition4_test( const void * rtdata, OnOffProtocol::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain4_test( void );
	INLINE_CHAINS void chain2_on( void );
	INLINE_CHAINS void chain3_off( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR
// }}}USR
// }}}RME

#endif /* WalkLight_H */

// }}}RME
